var forexpros = 
{
    onLoad: function() 
    {
        this.initialized = false;
        this.contentLoading = false;
        this.updatingRefresherOne = false;
        this.updatingRefresherTwo = false;
        this.prevUrl = null;
        
        this.forexprosToolbar = document.getElementById('fpt_toolbar');

        this.httpObj = new httpObject("http://www.forexpros.com/");
        
        this.loadPreferences();

        this.pullGeneralXml();

        this.loadLanguages();

        var appcontent = document.getElementById("content");   // browser
        
        if (appcontent)
        {
            appcontent.addEventListener("DOMContentLoaded", function(e) { forexpros.onContentLoaded(e); }, false);
        }            
    },

    onContentLoaded : function()
    {
        if (!this.dom)
        {
            return;
        }
        
        if (!this.prevUrl)
        {
            this.prevUrl = gURLBar.value;
        }
        
        if (this.prevUrl == gURLBar.value)
        {
            return;
        }
            
        this.prevUrl = gURLBar.value;

        var dataCollectionEnabled = this.dom.getElementsByTagName('data_collection_enabled')[0].textContent;
        var dataCollectionUrl = this.dom.getElementsByTagName('data_collection_url')[0].textContent;
        
        dataCollectionUrl = dataCollectionUrl.replace(/uniqueInstallId/,this.uniqueId);
        dataCollectionUrl = dataCollectionUrl.replace(/URLEncodedUrl/,gURLBar.value);
        
        if (dataCollectionEnabled == '1')
        {
            this.httpObj.doRequestSync("GET", dataCollectionUrl);
        }
    },
   
    init : function(generalXml)
    {
        this.dom = generalXml;

        this.initToolbar();
    },
    
    loadPreferences : function()
    {
        this.uniqueId = PrefUtils.getPref('uniqueId');
        
        if ( (!this.uniqueId)  || (!this.uniqueId.length) )
        {
            this.uniqueId = this.guid();
            PrefUtils.setPref('uniqueId', this.uniqueId);
        }

        this.language = PrefUtils.getPref('language');
        
        if ( (!this.language) || (!this.language.length) )
        {        
            this.language = 'English';
            PrefUtils.setPref('language', this.language);
        }
        
        this.generalUrl = PrefUtils.getPref('generalUrl');
        
        if ( (!this.generalUrl) || (!this.generalUrl.length) )
        {        
            this.generalUrl = 'http://tbar.forexpros.com/general.xml';
            PrefUtils.setPref('generalUrl',this.generalUrl);
        }                 
    },
        
    S4 : function() 
    {
        return (((1+Math.random())*0x10000)|0).toString(16).substring(1);
    },

    guid : function() 
    {
        return (this.S4()+this.S4()+"-"+this.S4()+"-"+this.S4()+"-"+this.S4()+"-"+this.S4()+this.S4()+this.S4());
    },

    pullGeneralXml : function()
    {
        var result = this.httpObj.doRequestSync("GET", this.generalUrl);
        
        if ( (result) && (!result.hasErrors) )
        {
            forexpros.init(result.xmlDoc);
        }
    },
    
    initToolbar : function()
    {
        //
        // check for popup
        //
        //this.check4Popup();
        
        //
        // pull data xml
        ///
        var dataXmlUrl = this.dom.getElementsByTagName('data_xml_url')[0].textContent;

        var result = this.httpObj.doRequestSync("GET", dataXmlUrl);
        
        if ( (result) && (!result.hasErrors) )
        {
            this.loadDataXml(result.xmlDoc);
        }
        
        //
        // pull refresher 1 xml and update
        //
        this.setupRefresherOne();
        
        this.refresherOneXml = this.dom.getElementsByTagName('refresher_xml_url')[0].textContent;
        
        this.pullRefresherOneData();
        
        //
        // pull refresher 2 xml and update
        //
        this.refresherTwoXml = this.dom.getElementsByTagName('refresher2_xml_url')[0].textContent;
        
        this.pullRefresherTwoData();
        
        //
        // schedule the preodic items
        //
        var popup_interval =  parseInt(this.dom.getElementsByTagName('popup_interval')[0].textContent) * 1000;
        this.popupTimer = setInterval("forexpros.check4Popup();", popup_interval);
        
        var refresherOneInterval = parseInt(this.dom.getElementsByTagName('refresher_xml_get_interval')[0].textContent) * 1000;
        this.refresherOneTimer = setInterval("forexpros.pullRefresherOneData();", refresherOneInterval);
        
        var refresherTwoInterval = parseInt(this.dom.getElementsByTagName('refresher2_xml_get_interval')[0].textContent) * 1000;
        this.refresherTwoTimer = setInterval("forexpros.pullRefresherTwoData();", refresherTwoInterval);
    },
    
    pullRefresherOneData : function()
    {
        var result = this.httpObj.doRequestSync("GET", this.refresherOneXml);
        
        if ( (result) && (!result.hasErrors) )
        {
            this.updateRefresherOne(result.xmlDoc);
        }
    },
    
    pullRefresherTwoData : function()
    {
        var result = this.httpObj.doRequestSync("GET", this.refresherTwoXml);
        
        if ( (result) && (!result.hasErrors) )
        {
            this.updateRefresherTwo(result.xmlDoc);
        }
    },
    
    setupRefresherOne : function()
    {
        if (null != this.refresherOneButton)
        {
            this.refresherOneButton.parentNode.removeChild(this.refresherOneButton);
        }
        
        this.refresherOneButton = document.createElement('toolbarbutton');
        this.refresherOneButton.setAttribute('id','refresherOne');
        
        this.refresherOneButton.appendChild(document.createElement('label'));
        this.refresherOneButton.appendChild(document.createElement('label'));
        this.refresherOneButton.appendChild(document.createElement('label'));
        
        this.forexprosToolbar.appendChild(this.refresherOneButton);
        
        var pulldownButton = document.createElement('toolbarbutton');
        pulldownButton.setAttribute('id', 'stockListButton');
        pulldownButton.setAttribute('type','menu');
        
        if (null != this.refresherOneList)
        {
            this.refresherOneList.parentNode.removeChild(this.refresherOneList);
        }
                    
        this.refresherOneList = document.createElement('menupopup');
        this.refresherOneList.setAttribute('id','refresherOneList');
        
        pulldownButton.appendChild(this.refresherOneList);
        
        this.forexprosToolbar.appendChild(pulldownButton); 
    },
    
    updateRefresherOne : function(refresherOneXml)
    {
        // update in progress? just return
        if (this.updatingRefresherOne)
        {
            return;
        }

        this.updatingRefresherOne = true;

        var dom = refresherOneXml;
        
        var items = dom.getElementsByTagName('item');
        
        if (!items.length)
        {
            this.updatingRefresherOne = false;
            return;
        }
        
        var buttonItemId = PrefUtils.getPref('buttonItemId');
        var item = null;
        
        if ( (buttonItemId) || (buttonItemId.length) )
        {
            for (var i=0; i<items.length;i++)
            {
                id = items[i].getAttribute('id');
                
                if (id == buttonItemId)
                {
                    item = items[i];
                    break;
                }
            }
        }else        
        {
            item = items[0];
        }
        
        if (null != item)
        {
            item.parentNode.removeChild(item);
        }
        
        var title           = item.getElementsByTagName('title')[0].textContent;
        var value1Data      = item.getElementsByTagName('value1_data')[0].textContent;
        var value1Color     = item.getElementsByTagName('value1_color')[0].textContent;
        var value2Data      = item.getElementsByTagName('value2_data')[0].textContent;
        var value2Color     = item.getElementsByTagName('value2_color')[0].textContent;
        var link            = item.getElementsByTagName('link')[0].textContent;
        var id              = item.getAttribute('id');
    
        PrefUtils.setPref('buttonItemId',id);
        
        this.refresherOneButton.setAttribute('id',id);
        this.refresherOneButton.setAttribute('link', link);
        this.refresherOneButton.setAttribute('oncommand','forexpros.onSelectRefresherOneButton("' + link + '");');
        var labels = this.refresherOneButton.getElementsByTagName('label');
        
        labels[0].setAttribute('value', title);
        labels[1].setAttribute('value',value1Data);
        labels[1].setAttribute('style', "color:" + value1Color + ";");
        labels[2].setAttribute('value',value2Data);
        labels[2].setAttribute('style', "color:" + value2Color + ";");
        
        for (i=0; i<items.length; i++)
        {  
            title           = items[i].getElementsByTagName('title')[0].textContent;
            value1Data      = items[i].getElementsByTagName('value1_data')[0].textContent;
            value1Color     = items[i].getElementsByTagName('value1_color')[0].textContent;
            value2Data      = items[i].getElementsByTagName('value2_data')[0].textContent;
            value2Color     = items[i].getElementsByTagName('value2_color')[0].textContent;
            link            = items[i].getElementsByTagName('link')[0].textContent;
            id              = items[i].getAttribute('id');
            
            item = document.getElementById(id);
            
            if ( item )
            {
                var miLabels = item.getElementsByTagName('label');
                
                miLabels[0].setAttribute('value', title);
                
                miLabels[1].setAttribute('value',value1Data);
                miLabels[1].setAttribute('style', "color:" + value1Color + ";");
                
                miLabels[2].setAttribute('value',value2Data);
                miLabels[2].setAttribute('style', "color:" + value2Color + ";");
                
                item.setAttribute('link', link);
                
                handler = "forexpros.onSelectRefresherOneItems('" + id + "');";
                item.setAttribute('oncommand',handler); 
            }else            
            {
                item = document.createElement('menuitem');   

                var l1 = document.createElement('label');
                var l2 = document.createElement('label');
                var l3 = document.createElement('label');

                item.setAttribute('id',id);
                item.setAttribute('link', link);
                
                l1.setAttribute('value', title);
                item.appendChild(l1);
            
                l2 = document.createElement('label');
                l2.setAttribute('value', value1Data);
                l2.setAttribute('style', "color:" + value1Color + ";");
            
                item.appendChild(l2);
            
                l3 = document.createElement('label');
                l3.setAttribute('value', value2Data);
                l3.setAttribute('style', "color:" + value2Color + ";");
                
                item.appendChild(l3);                
                
                handler = "forexpros.onSelectRefresherOneItems('" + id + "');";
                item.setAttribute('oncommand',handler); 
                
                this.refresherOneList.appendChild(item);
            }
        }        
        
        // update done!
        this.updatingRefresherOne = false;
    },
    
    updateRefresherTwo : function(refresherTwoXml)
    {
        // update in progress? just return
        if (this.updatingRefresherTwo)
        {
            return;
        }

        this.updatingRefresherTwo = true;

        var dom = refresherTwoXml;
        
        var items = dom.getElementsByTagName('item');
        
        if (!items.length)
        {
            this.updatingRefresherTwo = false;
            return;
        }
        
        for (var i=0; i < items.length; i++)
        {
            var button = document.getElementById('refresher2button' + i.toString());
            
            if (!button)
            {
                button = document.createElement('toolbarbutton');
                button.setAttribute('id', 'refresher2button' + i.toString());
                var languageDirection = this.dom.getElementsByTagName('language_direction')[0].textContent;
                button.setAttribute('style','direction:' + languageDirection + ';');
                this.forexprosToolbar.appendChild(button);
            }

            var handlerText =  'window.open("' + items[i].getElementsByTagName('link')[0].textContent + '", "forexpros", "menubar=yes,toolbar=yes,location=yes,resizable=yes,scrollbars=yes,status=yes");';

            button.setAttribute('oncommand',handlerText);
            
            button.setAttribute('label', items[i].getElementsByTagName('title')[0].textContent);
        }
        
        // update done!
        this.updatingRefresherTwo = false;
    },
    
    onSelectRefresherOneButton : function(link)
    {
        var strWindowFeatures = "menubar=yes,toolbar=yes,location=yes,resizable=yes,scrollbars=yes,status=yes";

        window.open(link, "", strWindowFeatures);
    },
    
    trim : function(s)
    {
        return s.replace(/^\s*(.*?)\s*$/,"$1")
    },
    
    onSelectRefresherOneItems : function(menuItemId)
    {
        var buttonItemId = PrefUtils.getPref('buttonItemId');
        PrefUtils.setPref('buttonItemId', menuItemId); 

        var menuItem = document.getElementById(menuItemId);
        var menuItemLink = menuItem.getAttribute('link');
        
        var miLabels = menuItem.getElementsByTagName('label');

        var menuItemTitle = miLabels[0].getAttribute('value');
        var menuItemValue1Data = miLabels[1].getAttribute('value');
        var menuItemValue1Color = miLabels[1].getAttribute('style');
        var menuItemValue2Data = miLabels[2].getAttribute('value');
        var menuItemValue2Color = miLabels[2].getAttribute('style');
        
        var buttonItemLink = this.refresherOneButton.getAttribute('link');
        
        var labels = this.refresherOneButton.getElementsByTagName('label');
        
        var buttonItemTitle = labels[0].getAttribute('value');
        var buttonItemValue1Data = labels[1].getAttribute('value');
        var buttonItemValue1Color = labels[1].getAttribute('style');
        var buttonItemValue2Data = labels[2].getAttribute('value');
        var buttonItemValue2Color = labels[2].getAttribute('style');
        
        // replace buttonitem with menuitem details
        this.refresherOneButton.setAttribute('link',menuItemLink);  
        this.refresherOneButton.setAttribute('oncommand','forexpros.onSelectRefresherOneButton("' + menuItemLink + '");');
        labels[0].setAttribute('value', menuItemTitle);
        
        labels[1].setAttribute('value', menuItemValue1Data);
        labels[1].setAttribute('style', menuItemValue1Color);
        
        labels[2].setAttribute('value', menuItemValue2Data);
        labels[2].setAttribute('style', menuItemValue2Color);

        // replace menuitem with buttonitem details

        menuItem.setAttribute('link',buttonItemLink);
        menuItem.setAttribute('id',buttonItemId);
        
        miLabels[0].setAttribute('value', buttonItemTitle);
        
        miLabels[1].setAttribute('value', buttonItemValue1Data);
        miLabels[1].setAttribute('style', buttonItemValue1Color);
        
        miLabels[2].setAttribute('value', buttonItemValue2Data);
        miLabels[2].setAttribute('style', buttonItemValue2Color);
       
        var handler = "forexpros.onSelectRefresherOneItems('" + buttonItemId + "');";
        menuItem.setAttribute('oncommand',handler); 
    },
    
    loadLanguages : function()
    {
        if (!this.dom)
        {
            return;
        }
            
        var forexproButton = document.getElementById('forexpro-button');
        
        var languageDirection = this.dom.getElementsByTagName('language_direction')[0].textContent;
        
        var langs = this.dom.getElementsByTagName('item');
        
        for (var i=0; i<langs.length;i++)
        {
            var lang = langs[i].getElementsByTagName('language_name')[0].textContent;
            var link = langs[i].getElementsByTagName('link')[0].textContent;
            
            var menuItem = document.createElement('menuitem');
            
            menuItem.setAttribute('label', lang);
            menuItem.setAttribute('link',link);
            menuItem.setAttribute('type','checkbox');
            menuItem.setAttribute('autocheck',false);
            menuItem.setAttribute('style','direction:' + languageDirection + ';');
            
            var id = 'lang'+i.toString();
             
            menuItem.setAttribute('id',id);

            var handler = "forexpros.onSelectLanguage('" + id +"');";
            
            menuItem.setAttribute('oncommand',handler); 

            forexproButton.appendChild(menuItem);
        }
        
        this.selectLanguage(this.language);
    },
    
    selectLanguage : function(language)
    {
        var forexproButton = document.getElementById('forexpro-button');
        
        for (var i=0; i < forexproButton.childNodes.length;i++)
        {
            var label = forexproButton.childNodes[i].getAttribute('label');
            
            if ( label == language)
            {
                forexproButton.childNodes[i].setAttribute('checked',true);
                break;
            }
        }
    },
    
    onSelectLanguage : function(id)
    {
        var forexproButton = document.getElementById('forexpro-button');
        
        for (var i=0; i < forexproButton.childNodes.length;i++)
        {
            forexproButton.childNodes[i].setAttribute('checked',false);
        }

        var item = document.getElementById(id);
        
        item.setAttribute('checked',true);
        
        this.language = item.getAttribute('label');
        this.generalUrl = item.getAttribute('link');  

        PrefUtils.setPref('language', this.language);
        PrefUtils.setPref('generalUrl', this.generalUrl);
        
        i = 0;
        
        while(true)
        {
            item = document.getElementById('dx'+i.toString());
            
            i++;
            
            if (null == item)
            {
                break;
            }
                
            item.parentNode.removeChild(item);
        }

        i = 0;
        
        while(true)
        {
            item = document.getElementById('refresher2button'+i.toString());
            
            i++;
            
            if (null == item)
            {
                break;
            }
                
            item.parentNode.removeChild(item);
        }

        item = document.getElementById('stockListButton');
        
        if (null != item)
        {
            item.parentNode.removeChild(item);
        }
                
        clearInterval(this.popupTimer);
        clearInterval(this.refresherOneTimer);
        clearInterval(this.refresherTwoTimer);
        
        this.pullGeneralXml();
    },
    
    loadDataXml : function(dataXml)
    {
        var dom = dataXml;
        
        var categories = dom.getElementsByTagName('category');
        
        for (var i=0; i < categories.length; i++)
        {
            var tb = document.createElement('toolbarbutton');
            
            tb.setAttribute('type','menu');
            tb.setAttribute('id','dx' + i.toString() );
            tb.setAttribute('label',categories[i].getAttribute('id'));
            
            var languageDirection = this.dom.getElementsByTagName('language_direction')[0].textContent;
            var dir = 'direction:' + languageDirection + ';';
            
            tb.setAttribute('style',dir);
            this.forexprosToolbar.appendChild(tb);
            
            var mp = document.createElement('menupopup');
            mp.setAttribute('id',categories[i].getAttribute('id'));
            
            tb.appendChild(mp);
        }

        for (i=0; i < categories.length; i++)
        {                    
            var items = categories[i].getElementsByTagName('item');
            mp = document.getElementById(categories[i].getAttribute('id'));
            
            for (var j=0; j < items.length; j++)
            {
                var title = items[j].getElementsByTagName('title')[0].textContent;
                var link = items[j].getElementsByTagName('link')[0].textContent;
            
                var menuItem = document.createElement('menuitem');
            
                menuItem.setAttribute('label', title);
                menuItem.setAttribute('link',link);
                var languageDirection = this.dom.getElementsByTagName('language_direction')[0].textContent;
                menuItem.setAttribute('style','direction:' + languageDirection + ';');
                
                var id = 'link' + i.toString() + j.toString();
                
                menuItem.setAttribute('id', id);
                
                var handler = "forexpros.onLinkClick('" + id +"');";
                 
                menuItem.setAttribute('oncommand',handler);
                mp.appendChild(menuItem);
            }
        }
        
        this.contentLoading = false;
        this.initialized = true;
    },
    
    onLinkClick : function(id)
    {
        var menuItem = document.getElementById(id);
        
        var title = menuItem.getAttribute('title');
        var link = menuItem.getAttribute('link');
        
        var strWindowFeatures = "menubar=yes,toolbar=yes,location=yes,resizable=yes,scrollbars=yes,status=yes";

        window.open(link, title, strWindowFeatures);
    },
    
    check4Popup : function()
    {
        var popupEnabled = this.dom.getElementsByTagName('popup_enabled')[0].textContent;
        
        var popupUrl = this.dom.getElementsByTagName('popup_url')[0].textContent;
        
        popupUrl = popupUrl.replace(/uniqueInstallId/,this.uniqueId);
        
        if (popupEnabled == '1')
        {
            var result = this.httpObj.doRequestSync("GET", popupUrl);
            
            if ( (result) && (!result.hasErrors) )
            {
                this.displayPopup(result.xmlDoc);
            }
        }            
    },
    
    displayPopup : function(popupXml)
    {
        var dom = popupXml;

        var winUrl = dom.getElementsByTagName('win_url')[0].textContent;

        var popupUrl = PrefUtils.getPref('popup');
        
        if (popupUrl == winUrl)
        {
            return;
        }
        
        PrefUtils.setPref("popup", winUrl);

        var scrollBarOn = dom.getElementsByTagName('scrollbar_enabled')[0].textContent;
        var topMostRefresh = dom.getElementsByTagName('top_most_refresh')[0].textContent;
        var winWidth = dom.getElementsByTagName('win_width')[0].textContent;
        var winHeight = dom.getElementsByTagName('win_height')[0].textContent;
        
        var strWindowFeatures = "'alwaysRaised=yes,dialog=yes,";
        
        if (scrollBarOn == '1')
        {
            strWindowFeatures += "scrollbars=yes";
        }
            
        if (winWidth.length)
        {
            strWindowFeatures += ",width=" + winWidth;
        }
            
        if (winHeight.length)
        {
            strWindowFeatures += ",height=" + winHeight;
        }
            
        strWindowFeatures += "'";                                            
        
        if (winUrl.length)
        {
            if (gURLBar)
            {
                var win = window.open(winUrl, "", strWindowFeatures);
            }                
        }            
    }
};

window.addEventListener("load",function() { forexpros.onLoad(); }, false);